// Copyright (c) 1997-2009 Nokia Corporation and/or its subsidiary(-ies).
// All rights reserved.
// This component and the accompanying materials are made available
// under the terms of "Eclipse Public License v1.0"
// which accompanies this distribution, and is available
// at the URL "http://www.eclipse.org/legal/epl-v10.html".
//
// Initial Contributors:
// Nokia Corporation - initial contribution.
//
// Contributors:
//
// Description:
//

#include "CImplementationClassTwo.h"

// Construction and destruction functions

CImplementationClassTwo* CImplementationClassTwo::NewL(TAny* aParams)
	{
	CImplementationClassTwo* self=new(ELeave) CImplementationClassTwo(aParams);  
	CleanupStack::PushL(self);
	self->ConstructL(); 
	CleanupStack::Pop();
	return self;
	}

CImplementationClassTwo::~CImplementationClassTwo()
	{
	delete iDescriptor;
	}

CImplementationClassTwo::CImplementationClassTwo(TAny* aInitParams)
:  iInitParams((CExampleInterface::TExampleInterfaceInitParams*)aInitParams)
	{
	// See ConstructL() for initialisation completion.
	}

void CImplementationClassTwo::ConstructL()
// Safely complete the initialization of the constructed object	
	{
	// Set up the data to pass back
	_LIT(KDescriptor, "Using Implementation Two\n");
	iDescriptor = KDescriptor().AllocL();
	}


// Implementation of CExampleInterface

void CImplementationClassTwo::DoMethodL(TDes& aString)
	{
	aString = *iDescriptor;

	if (iInitParams)
		iInitParams->integer=2;
	}

